program ProxyLib_Demo;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  PByte = ^Byte;
  PDataArray = ^DataArray;
  DataArray = array [0..10766] of Byte;

  //RFDevice
function RFDevice_Initialize(): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RFDevice_Initialize';
procedure RFDevice_Cleanup(); cdecl;
  external 'RFDevice_proxy.dll' name 'RFDevice_Cleanup';
  //RF625Device
function CreateRF625Device_1(devBlockHandle: THandle): THandle; cdecl;
  external 'RFDevice_proxy.dll' name 'CreateRF625Device_1';
function RF625Device_Connect(rf625DeviceHandle: THandle): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF625Device_Connect';
function RF625Device_GetResult(rf625DeviceHandle: THandle; arrayPointer: PByte): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF625Device_GetResult';
function RF625Device_ReadParams(rf625DeviceHandle: THandle): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF625Device_ReadParams';
function RF625Device_Disconnect(rf625DeviceHandle: THandle): BOOLEAN; cdecl;
  external 'RFDevice_proxy.dll' name 'RF625Device_Disconnect';
procedure DisposeRF625Device(rf625DeviceHandle: THandle); cdecl;
  external 'RFDevice_proxy.dll' name 'DisposeRF625Device';
  //RFLanDetector
function CreateRFLanDetector(): THandle; cdecl;
  external 'RFDevice_proxy.dll' name 'CreateRFLanDetector';
function RFLanDetector_Search(rfDev: THandle; devType: Word; timeout: integer): integer; cdecl;
  external 'RFDevice_proxy.dll' name 'RFLanDetector_Search';
function RFLanDetector_GetDevBlock(rfDev: THandle; index: integer): THandle; cdecl;
  external 'RFDevice_proxy.dll' name 'RFLanDetector_GetDevBlock';
procedure DisposeRFLanDetector(rfLanDetectorHandle: THandle); cdecl;
  external 'RFDevice_proxy.dll' name 'DisposeRFLanDetector';

var
  _connected: boolean;
  _res: boolean;
  name: string;
  devCount: integer;
  devType: Word;
  _rfLanDetectorHandle: THandle;
  _rf625DeviceHandle: THandle;
  _devBlockHandle: THandle;
  _arr1: DataArray;
  _arr: PByte;
  i: integer;

begin
  try
    _connected := RFDevice_Initialize();
    if _connected <> TRUE then
    begin
      WriteLn('Cant init library');
      ReadLn(name);
      Exit;
    end;
    _rfLanDetectorHandle := CreateRFLanDetector();
    devType := 625;
    devCount := RFLanDetector_Search(_rfLanDetectorHandle, devType, 2);
    if devCount < 1 then
    begin
      WriteLn('Devices not found');
      ReadLn(name);
      Exit;
    end;
    _devBlockHandle := RFLanDetector_GetDevBlock(_rfLanDetectorHandle, 0);
    _rf625DeviceHandle := CreateRF625Device_1(_devBlockHandle);
    _connected := RF625Device_Connect(_rf625DeviceHandle);
    if _connected <> TRUE then
    begin
      WriteLn('Unable to connect');
      ReadLn(name);
      Exit;
    end;
    _res := RF625Device_ReadParams(_rf625DeviceHandle);
    if _res = TRUE then
      begin
        WriteLn('Params read');
      end;
    for i := 0 to 10 - 1 do
    begin
      _arr := @_arr1;
      _res := RF625Device_GetResult(_rf625DeviceHandle, _arr);
      if _res <> TRUE then
      begin
        WriteLn('Getting data error');
      end;
      if _res = TRUE then
      begin
        WriteLn('Got data');
      end;
    end;
    RF625Device_Disconnect(_rf625DeviceHandle);
    DisposeRF625Device(_rf625DeviceHandle);
    DisposeRFLanDetector(_rfLanDetectorHandle);
    RFDevice_Cleanup();
    WriteLn('Done');
    ReadLn(name);
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
